' FT800 Sprites.bas for the FT800
' Based on the Gameduino 2 library by James Bowman, http://excamera.com/sphinx/gameduino2/
' Requires Bascom 2.0.7.8 or greater

$Regfile = "M328pdef.dat"
$Crystal = 8000000
$Baud = 19200
$HwStack = 100
$SwStack = 100
$FrameSize = 400
$NOTYPECHECK

Config ft800=spi , ftsave=0, ftdebug=0 , ftcs=portb.2, ftpd=portb.1

Config Base = 0
Config Submode = New
Config Spi = Hard, Interrupt = Off, Data_Order = Msb, Master = Yes, Polarity = Low, Phase = 0, Clockrate = 4, Noss = 1
SPSR = 1  ' Makes SPI run at 8Mhz instead of 4Mhz

$Include "FT800.inc"
$Include "FT800_Functions.inc"

Spiinit

Dim t As Byte
Dim j As Byte
Dim nspr As Integer
Dim i As Integer
Dim tempi As Integer
Dim p1 As Dword
Dim p2 As Dword
Dim dw As Dword
Dim v As Dword
Dim r As Dword
Dim ptr1 As Word , ptr2 As Word, ptr3 As Word

if  FT800_Init()=1 then

   END    ' Initialise the FT800
end if

TempDW = LoadLabel(sprites_assets)
LoadCmd TempDW, 3708

t = 0

Do

   ptr1 = 0
   ptr3 = 0

   j = t

   Clear_B 1,1,1
   Begin_G BITMAPS

   nspr = 19 * t

   If 256 > nspr Then
      nspr = 256
   End If

   If 2001 < nspr Then
      nspr = 2001
   End If

   For i = 0 to nspr-1

      ptr3 = ptr2 + j
      v = Lookup (ptr1,sprites)
      r = Lookup (ptr3,circle_data)
      incr ptr1
      incr j
      cmd32 v + r
   Next

   ColorRGBdw &H000000
   Color_A 140
   LineWidth 30 * 16
   Begin_G Lines
   Vertex2II FT_DispWidth / 2 - 110, FT_DispHeight * 0.4 +25, 0, 0
   Vertex2II FT_DispWidth / 2 + 110, FT_DispHeight * 0.4 +25, 0, 0
   RestoreContext
   CmdNumber FT_DispWidth / 2 - 25, FT_DispHeight * 0.4 , 31, OPT_RIGHTX, nspr
   CmdText   FT_DispWidth / 2 - 10, FT_DispHeight * 0.4 , 31, 0, "Sprites"
   UpdateScreen
   Incr t

Loop

End




'------------------------------------------------------------------------------------------------------------

sprites_assets: ' 3708
   DATA &H00,&H00,&H00,&H05,&H00,&H00,&H00,&H01,&H10,&H20,&H00,&H08,&H10,&H40,&H00,&H07
   DATA &H22,&HFF,&HFF,&HFF,&H00,&H00,&H00,&H00,&H78,&H9C,&HE5,&H5C,&HCD,&H6A,&H1B,&HC9
   DATA &H16,&H6E,&HB2,&H52,&H20,&H90,&HBB,&HCA,&H78,&H11,&H98,&H2C,&H66,&H15,&H98,&H85
   DATA &H98,&H17,&H10,&H59,&H7A,&H31,&H0F,&HE0,&H47,&H18,&H2F,&HFD,&H02,&H6D,&H89,&H01
   DATA &H43,&HBC,&HC8,&H26,&H8B,&H01,&H0D,&H44,&H37,&H30,&HD8,&HE4,&H2E,&HE4,&H85,&H16
   DATA &H06,&H19,&HBC,&H32,&H36,&H34,&HBA,&H0C,&HE4,&H0A,&HDB,&HE0,&HA0,&HC4,&H76,&H06
   DATA &HD9,&HC6,&H16,&H16,&H38,&H21,&H63,&HA2,&H5B,&H5F,&H9D,&HAE,&HAE,&HBF,&H53,&H25
   DATA &H67,&H8C,&H13,&H3B,&HA9,&HC2,&HB2,&HD4,&HDF,&H77,&HCE,&HA9,&HEA,&HEE,&HFA,&H39
   DATA &H55,&HA7,&H3B,&H49,&H2E,&H90,&H9A,&H49,&H96,&HF4,&HEA,&HC3,&HE4,&H3C,&H19,&H24
   DATA &H7B,&H49,&H4F,&HFC,&H6A,&H8B,&H63,&H56,&HBA,&H9B,&HDE,&H4B,&HEF,&HA7,&HDF,&H8B
   DATA &HBF,&H7B,&HE9,&HDD,&HB4,&H94,&HFA,&H68,&H7D,&HF8,&H7D,&HFA,&H7D,&H80,&HA1,&HA4
   DATA &H43,&H38,&H18,&H73,&H5B,&HFD,&HFD,&HE9,&HD3,&HFE,&HFE,&HDC,&H96,&H8F,&H6A,&H46
   DATA &H08,&H55,&H8C,&H30,&H4A,&HA5,&H88,&H49,&HDF,&H0B,&H94,&H4D,&HA3,&H73,&H5B,&HB1
   DATA &HFA,&HA3,&H7C,&HFD,&HFD,&H50,&HFD,&H55,&HFD,&HFA,&HFB,&HA1,&HFA,&H4F,&H9F,&H06
   DATA &HEA,&H7F,&H81,&HEB,&H73,&HB1,&H74,&HB2,&H52,&H1F,&H4E,&HEC,&H86,&HD1,&H89,&HDD
   DATA &H93,&H95,&HF9,&HA5,&H93,&H15,&H1E,&H9D,&HE9,&H40,&H7A,&H72,&H91,&H43,&HE7,&H97
   DATA &H3A,&HCB,&HAD,&HEE,&H68,&H54,&H1F,&H9E,&HAC,&H70,&H8C,&HC9,&HC5,&HCE,&HF2,&H4C
   DATA &H07,&H0C,&HD8,&HE0,&H70,&H68,&H00,&HA3,&HBB,&H5D,&H5E,&HF3,&HF1,&H52,&H83,&H18
   DATA &H27,&H2B,&HE5,&HB5,&HF9,&H25,&H1F,&HDF,&HD8,&H79,&H78,&H30,&H7D,&H9A,&H7D,&H98
   DATA &H3E,&H7D,&H78,&HB0,&HB1,&HE3,&HE3,&H0B,&H02,&H2F,&H8F,&H08,&H5F,&H60,&H70,&H68
   DATA &H20,&H79,&H4E,&H9A,&HF0,&H5F,&H8E,&HA7,&H4F,&H7F,&H39,&H0E,&HE3,&H93,&HC7,&HE5
   DATA &HD1,&H64,&H10,&H5F,&H90,&H25,&H0C,&H59,&H57,&H1A,&H42,&HD2,&H4A,&H43,&H58,&H9A
   DATA &H18,&H31,&HF4,&H62,&HA9,&H97,&HEA,&HCF,&H00,&H63,&H56,&HFD,&HF1,&HAC,&H5E,&H9A
   DATA &HD6,&H7A,&H29,&H83,&HFE,&H47,&HDC,&HB7,&H19,&HDD,&HBD,&H0C,&HDA,&H4C,&H36,&H93
   DATA &HA3,&HE4,&HBD,&HB8,&HC7,&H71,&H87,&HBB,&HF7,&H37,&HD0,&H81,&H40,&HCF,&H45,&H7E
   DATA &HCF,&H30,&HDA,&HC0,&H65,&H1B,&H51,&HF8,&HAA,&HC1,&HB0,&HA5,&H8F,&H3C,&H5C,&H4A
   DATA &HE7,&HE8,&H20,&H47,&HDB,&HA2,&HBC,&HAE,&HB4,&H89,&H36,&H0B,&H5C,&H49,&H87,&HD1
   DATA &HB8,&HEC,&H7B,&HD9,&HB2,&H7D,&H0C,&H69,&HD3,&HC1,&HAE,&H28,&H2D,&HEC,&HA0,&H67
   DATA &HA2,&HEC,&HDE,&H45,&H73,&H5B,&H0B,&H79,&HEB,&H42,&HA6,&H7B,&H78,&H6E,&H4B,&H4B
   DATA &H12,&H56,&H1E,&H95,&H47,&H27,&H1F,&H4F,&H3E,&H6A,&H0E,&HE1,&HE8,&HF5,&H80,&H2A
   DATA &H4C,&H69,&HE9,&HEF,&HDB,&HF2,&H66,&HB6,&HDB,&H09,&HEC,&HCF,&H6D,&H99,&HD9,&HB4
   DATA &HAF,&H59,&HC8,&HFD,&HD7,&HA1,&H36,&H00,&H99,&HFE,&HEB,&H70,&H0B,&H5A,&H10,&HAD
   DATA &H0F,&H96,&HC3,&HF8,&H8B,&HB3,&HF2,&HE8,&HC5,&H59,&H48,&H03,&H70,&HD4,&H30,&HA4
   DATA &H01,&HF5,&HCC,&H3E,&H40,&HDE,&H2F,&HBB,&H66,&H8C,&H6B,&HE1,&H57,&H99,&HD0,&H6A
   DATA &HC7,&H32,&HF2,&HB6,&H1F,&H4E,&H01,&HB4,&H29,&HF2,&H7A,&HF2,&H52,&HB4,&HFC,&H54
   DATA &H7E,&H77,&HD1,&H75,&HD9,&H82,&HE8,&H4E,&HEF,&H81,&H67,&HA1,&H2F,&HD1,&HB6,&HF3
   DATA &H11,&H90,&HDA,&HE9,&H4B,&HAB,&H75,&HF7,&H72,&H54,&HE7,&H81,&H60,&HA8,&HB4,&H2E
   DATA &H34,&H9E,&H7B,&HB9,&H67,&HE2,&H8E,&H34,&H59,&HD0,&HFA,&HB3,&HDC,&HAA,&H29,&H6D
   DATA &H96,&HB0,&HED,&H58,&HE8,&H19,&HD2,&H4A,&H43,&H2F,&H47,&HCE,&HBD,&HFA,&HA9,&H33
   DATA &HD0,&H63,&H6B,&H7F,&H1D,&H52,&H53,&HF6,&HDB,&H4D,&HEB,&H9B,&H8D,&HE2,&HBA,&H64
   DATA &HD6,&H37,&H9D,&HE4,&HD9,&H13,&H67,&H18,&HC7,&HE9,&H3A,&HE2,&H9B,&H4E,&HFA,&HDC
   DATA &H9A,&HDF,&H1C,&H79,&HE7,&HEA,&H9A,&HF2,&HEE,&HF5,&H71,&HED,&HDB,&H0C,&H1F,&H35
   DATA &H19,&H3C,&HAA,&H19,&H21,&H54,&H31,&HE2,&H57,&HEE,&HBA,&H5D,&HD7,&H4F,&H4C,&HA5
   DATA &HC6,&HC9,&H4A,&HA9,&H11,&H42,&H26,&H76,&H5B,&HDD,&H56,&H37,&HBF,&HFE,&H41,&HBC
   DATA &HD5,&HE5,&H74,&H60,&HBE,&H90,&HD6,&H9E,&H55,&H9F,&H55,&H2B,&HD5,&H67,&HCC,&HBC
   DATA &HE2,&H5B,&HC7,&HAF,&H43,&H82,&H87,&H32,&HB7,&H15,&HF3,&HAF,&HEE,&HA7,&HF8,&HBB
   DATA &H1F,&HF0,&HB1,&H08,&H07,&H76,&H9F,&HC1,&HEF,&HA6,&HDF,&H09,&HFC,&H3B,&HA9,&HC1
   DATA &H97,&H07,&H0A,&H0F,&H93,&H18,&HBE,&HF7,&HF4,&H9D,&HE1,&H5F,&HFA,&H0C,&H25,&H7D
   DATA &H19,&HFC,&HB2,&HFA,&H63,&HF2,&H9A,&HC1,&HA3,&H5F,&H3E,&HA1,&HFD,&HD6,&H87,&H68
   DATA &HBB,&H9D,&HE5,&HC9,&H45,&HA6,&H0F,&H40,&HDF,&H77,&H2E,&H66,&HD6,&H47,&H62,&HC6
   DATA &H1A,&HEA,&H5F,&H25,&HDE,&HDD,&HEE,&H6E,&H33,&H1E,&H62,&H8E,&H77,&HB7,&H47,&HA3
   DATA &H18,&H0E,&H0F,&H33,&HA6,&H7F,&H34,&H8A,&HD9,&H97,&HD2,&H2C,&H3E,&HB9,&H08,&HCB
   DATA &HF5,&H61,&H77,&H3B,&H8C,&H4B,&H74,&H6C,&HFD,&H78,&H7C,&HEC,&HF9,&HBB,&HE6,&H49
   DATA &HCE,&HDA,&HC4,&HC8,&H2F,&H7C,&HBB,&HAA,&H3F,&HC3,&HCB,&HBD,&H3D,&H39,&H7E,&H8A
   DATA &HEF,&HA9,&H3D,&H7B,&HCB,&H51,&H31,&HF6,&HCA,&H4F,&H39,&H3E,&H14,&H1C,&H39,&HAA
   DATA &H2A,&H54,&HF3,&HE4,&H37,&H30,&H32,&HA9,&H6F,&H40,&HC7,&H60,&H1B,&H0C,&H2A,&H05
   DATA &H7A,&HC9,&HFC,&HA8,&H62,&HA4,&HCA,&H82,&HFC,&HD6,&H36,&HAC,&HFB,&H33,&H84,&HAC
   DATA &H28,&H41,&H9B,&HCD,&HD6,&H35,&H9C,&HDB,&H82,&H97,&HF2,&HDF,&H8F,&HF0,&H4C,&HB8
   DATA &HF9,&H3B,&HE1,&HE5,&H11,&H8F,&H13,&H7A,&HF2,&H11,&H5E,&H50,&H48,&HC3,&H8D,&H48
   DATA &HDE,&HB8,&H6E,&HA5,&H76,&HB2,&H17,&H61,&HB4,&H8B,&HB9,&H61,&H08,&H5F,&H17,&H58
   DATA &H48,&H43,&H5B,&HAE,&H1B,&HAC,&H8B,&HDC,&H66,&H19,&H7B,&H52,&H73,&H3B,&H58,&H86
   DATA &H2C,&HC7,&H33,&HB9,&H86,&HE6,&H32,&H32,&H29,&HBF,&H97,&H33,&HDA,&HF2,&HCE,&HB1
   DATA &HAD,&H0F,&HF2,&HB2,&HF1,&H16,&HB2,&HFC,&H9E,&H59,&H97,&H7F,&H5C,&H1D,&HB3,&H42
   DATA &HFB,&H9E,&H60,&HDC,&HF0,&H79,&H60,&H92,&H60,&H9D,&H2F,&H8C,&HA2,&HAF,&H0B,&H33
   DATA &H80,&HF2,&H18,&HDA,&H09,&HD6,&HEF,&HF8,&H16,&HB6,&HB1,&H13,&H42,&H49,&H0E,&HD8
   DATA &H86,&H5C,&H29,&HE0,&HD0,&HFE,&HFE,&H46,&HBE,&H8A,&HE0,&HA3,&HB4,&H6A,&HA8,&H56
   DATA &H17,&H6C,&H9C,&HDA,&HB5,&HC6,&H79,&HDB,&HD0,&H80,&HB5,&HDB,&H4F,&HAD,&HD5,&H57
   DATA &H95,&H9A,&HD3,&HA7,&HD2,&HB7,&HF7,&HFD,&H7B,&H91,&HD0,&H37,&HA2,&HF5,&HC9,&HFF
   DATA &HAE,&H1F,&HD5,&HCC,&HFD,&HCA,&H81,&HE4,&H64,&H39,&HA3,&H40,&H69,&H65,&H5D,&H9C
   DATA &HBF,&H26,&HB0,&H1C,&H1D,&H28,&H0D,&H84,&H6A,&H46,&HDE,&HBB,&HE7,&H16,&H94,&HAC
   DATA &HC5,&H30,&H3C,&H39,&HDA,&H55,&HC0,&H1D,&HE9,&H68,&HB0,&HB4,&H5B,&HF2,&H4E,&HE9
   DATA &H3D,&HFB,&H5E,&HFD,&H8B,&H3B,&H8B,&H45,&HBF,&H8A,&H94,&H59,&HD9,&H43,&HE5,&HAC
   DATA &H2D,&HCF,&HFD,&H7D,&HE7,&H0C,&HC8,&HA3,&HF5,&H61,&H79,&H24,&H10,&H42,&HCD,&H73
   DATA &H84,&HBB,&H01,&HF2,&HCD,&H22,&H67,&H8E,&HA7,&H9D,&H19,&HF7,&H9D,&H66,&H58,&H16
   DATA &H68,&H6C,&HA6,&HAB,&HC4,&HCE,&HDF,&H32,&H4B,&H9E,&HAF,&H61,&H0C,&HD5,&H8C,&H58
   DATA &HFA,&H1A,&HAF,&HBC,&H4C,&H62,&H8E,&H65,&H64,&H1F,&HAD,&H0F,&H35,&HEA,&HAE,&H33
   DATA &HD2,&HD1,&HFA,&H70,&HEA,&HF0,&H59,&H95,&H50,&H39,&H7B,&H2B,&H50,&HAC,&H3A,&H0A
   DATA &HF9,&HB4,&HC8,&HB3,&HF6,&HEE,&H82,&H96,&H31,&H19,&HB6,&H85,&HB4,&H56,&H1F,&HC2
   DATA &HBB,&H46,&HE6,&HF6,&H2D,&HA4,&HCE,&H22,&H07,&H6A,&H18,&H41,&H35,&H23,&H84,&H4A
   DATA &H46,&H14,&HBD,&HC9,&HE9,&H64,&HC5,&HCC,&H3E,&H8A,&HFE,&H55,&HE5,&HFA,&HD0,&HF6
   DATA &H7F,&HD4,&HD1,&HEE,&H36,&HFC,&H23,&HA0,&HC8,&HB6,&HAC,&H3A,&H8A,&H8C,&HF5,&H23
   DATA &H73,&H0D,&HC9,&H46,&H15,&HC3,&HB5,&H4F,&HDA,&HBB,&HDB,&HB0,&HE5,&HFB,&H5F,&H38
   DATA &HA6,&H33,&H5F,&HC3,&H18,&HAA,&H19,&HB1,&HB3,&H74,&HF3,&HFC,&HBE,&H4F,&H4F,&H58
   DATA &H25,&H8A,&HA1,&H18,&H25,&H43,&H0C,&HA0,&H18,&H7D,&H79,&H06,&H50,&HF4,&HE2,&HBD
   DATA &H59,&H4E,&H87,&H94,&H1D,&HD0,&HFC,&H80,&HF6,&HD1,&H4D,&H86,&H29,&H4B,&HF3,&H0C
   DATA &H73,&HB6,&HA6,&H64,&HB1,&H57,&HA5,&H46,&H09,&H1B,&HD5,&HC7,&H81,&H98,&H33,&H39
   DATA &H35,&H3F,&HE0,&HE6,&H86,&HD7,&H22,&H71,&H2B,&HF6,&H36,&HEA,&HAF,&HD8,&H9B,&HF8
   DATA &H20,&HDF,&H77,&HE1,&H19,&H7A,&H65,&H7D,&H1C,&H63,&HDC,&HCA,&HFA,&H45,&H18,&HE3
   DATA &HEA,&H31,&H9E,&H31,&H6E,&HFD,&HFE,&H22,&H8C,&HD8,&H28,&H7E,&H7D,&H18,&H1E,&HCA
   DATA &HEE,&HC9,&H5B,&H68,&H32,&H08,&H33,&H8A,&H91,&H37,&H88,&H63,&H14,&H0E,&HEF,&H21
   DATA &HFA,&HE3,&H36,&HA3,&H7B,&H96,&HB3,&HA1,&HD6,&HC6,&H69,&HF4,&H7D,&H56,&HC5,&H7C
   DATA &HC0,&H18,&HFD,&H53,&H9A,&H21,&H98,&H1A,&H4C,&H86,&H2C,&H93,&H1A,&HBB,&H8B,&HFF
   DATA &HBA,&H9C,&HF9,&HAF,&H9A,&H2E,&H7F,&HAF,&HE6,&H5B,&H90,&HD6,&H73,&HFD,&HFE,&H0C
   DATA &HC2,&H99,&H7D,&H30,&HE5,&H97,&HA5,&H96,&H88,&HAC,&H89,&HA7,&H5D,&H97,&H00,&HD6
   DATA &H4D,&H86,&H89,&HA3,&H14,&H69,&H2D,&HA8,&H21,&H2F,&HA1,&H57,&HBE,&HA6,&H18,&H77
   DATA &HAC,&HF9,&HB1,&HFC,&H5D,&HA0,&HC9,&HA6,&H18,&HB1,&H37,&HCD,&H2C,&H7F,&H2B,&H46
   DATA &H96,&H1C,&H89,&H1E,&HE0,&HC8,&HCC,&HF2,&H77,&H56,&HE0,&HBD,&HEE,&HB6,&HDC,&HBB
   DATA &H2C,&HB2,&HFC,&H9D,&H15,&HFA,&HD7,&H85,&HBE,&H75,&H33,&HCB,&HDF,&HCD,&H0B,&H96
   DATA &HAF,&H48,&H34,&H76,&HF8,&HC7,&H35,&H8E,&HFD,&H89,&H18,&H5E,&H1E,&H5D,&H4E,&HFE
   DATA &HB2,&HF6,&HAF,&H5A,&H3E,&H36,&H06,&H61,&H15,&H02,&HEB,&H18,&H21,&HC6,&HC6,&H8E
   DATA &H5A,&H07,&HE1,&H65,&H31,&H02,&H22,&HBA,&H01,&HD9,&HD6,&H41,&H23,&HAD,&H5A,&H47
   DATA &H01,&HE6,&H33,&H48,&H1E,&H23,&H70,&H7C,&H05,&H35,&H54,&H3E,&H42,&H29,&H32,&H24
   DATA &HB4,&HBE,&H8A,&HF8,&H2E,&H8E,&H61,&HA2,&H3E,&HC3,&H45,&H5D,&H06,&HE2,&HC2,&HB0
   DATA &H6E,&HEB,&H46,&HA8,&HA8,&HF3,&HB4,&HB1,&HF3,&HF8,&HCC,&H96,&H46,&H7E,&H7C,&HA6
   DATA &H71,&H3A,&H73,&H21,&H79,&H55,&HB3,&H90,&H7D,&H9F,&H71,&H35,&H2B,&HC8,&H68,&H1D
   DATA &H31,&HCD,&HB1,&HFB,&H43,&H33,&HC2,&H28,&H66,&HE5,&H53,&H87,&HA1,&HFD,&HE3,&H44
   DATA &HC5,&H48,&HC4,&H66,&H00,&HBD,&H3C,&HFA,&H91,&HDD,&H7D,&H99,&H3A,&H14,&HE8,&HFB
   DATA &H64,&H4F,&HFC,&HE7,&H76,&HFF,&H85,&H6C,&HAB,&H8B,&H1D,&H18,&H4F,&H87,&HD2,&H3C
   DATA &H28,&H35,&HA4,&H67,&H32,&H70,&H18,&HAB,&H0A,&H2F,&HAF,&HB5,&HBA,&HE5,&HB5,&H02
   DATA &H5F,&HB5,&HE5,&H85,&H5D,&HC4,&H88,&H0D,&H64,&H39,&H02,&H16,&H64,&HE6,&HEA,&HD0
   DATA &H2C,&HAC,&HB8,&H91,&H69,&H5F,&H28,&H8D,&HF3,&H64,&H73,&H6F,&H97,&H8D,&HF5,&H99
   DATA &HDB,&HBA,&HFD,&H76,&H6E,&H2B,&H8C,&H4E,&H1E,&H8B,&HB9,&HF4,&H6B,&HC9,&HF0,&H6C
   DATA &H60,&H95,&H37,&HB6,&H8F,&H02,&H59,&H30,&HB8,&HF5,&H54,&H53,&HD6,&H5F,&H07,&H56
   DATA &HB2,&H6A,&H2D,&HD6,&H45,&H37,&H76,&H4C,&H49,&H4E,&H16,&HB1,&H9F,&HFC,&H0A,&HF2
   DATA &HED,&HB7,&HE5,&HD1,&H2F,&HC7,&HA1,&HF5,&H61,&HC8,&H86,&H7A,&HE6,&HB9,&HAD,&HEC
   DATA &H03,&H24,&H39,&HEC,&H73,&HA5,&HC9,&HC5,&HD8,&H8E,&HE4,&HE4,&HE2,&H4C,&H07,&H5E
   DATA &H73,&H88,&H41,&H91,&HBD,&H61,&H46,&HA9,&H81,&HA8,&HDD,&H8B,&H32,&HF8,&HB2,&H28
   DATA &HC6,&HFC,&H52,&H77,&H7B,&HEA,&H10,&H11,&HC0,&H2E,&H07,&H8C,&HF9,&HA5,&H99,&H0E
   DATA &HB4,&HF0,&H0C,&H94,&HB3,&HBC,&H06,&H46,&H67,&H19,&H7B,&HB0,&H6E,&H14,&HB1,&HC2
   DATA &H3B,&HCB,&HD4,&HCF,&HB9,&H7B,&HD0,&HB0,&H50,&H5E,&H23,&H14,&H77,&H8A,&HBF,&H47
   DATA &H0D,&H0D,&HF3,&H4B,&H6A,&H94,&HF2,&H71,&H2A,&H23,&H69,&HE7,&H62,&H98,&H15,&H03
   DATA &H99,&H43,&HAF,&H2E,&HD1,&H1D,&HAC,&H46,&H17,&HB4,&H5E,&H1F,&HD7,&HF1,&H9F,&H3E
   DATA &H3E,&HB9,&H88,&HBE,&H1D,&H2B,&H2C,&HAD,&HEE,&H4C,&HC7,&H8F,&H00,&HBF,&HAC,&H7E
   DATA &HCD,&HE0,&H51,&H62,&H2C,&HEC,&HDC,&H7E,&HCB,&H45,&H86,&H6A,&H46,&HF6,&H21,&HD6
   DATA &HD2,&H16,&H76,&HC2,&HD1,&H9F,&H84,&H67,&H1F,&H62,&H38,&HF5,&H7B,&H31,&H34,&H54
   DATA &H7A,&H55,&H3B,&H8A,&H50,&H8F,&H69,&HF9,&HD2,&HA9,&H32,&HFB,&H6C,&HB6,&HC2,&HF5
   DATA &HEB,&H72,&HEF,&HB3,&H82,&H75,&HDA,&HEA,&H83,&HAA,&HC7,&H68,&H0B,&H8F,&H61,&H2F
   DATA &HC9,&H1E,&H54,&H7B,&HF0,&H53,&HFC,&H08,&H82,&H1E,&H8D,&H8C,&H95,&H59,&H30,&H18
   DATA &H79,&H1A,&H1B,&HA5,&H85,&HA0,&HFD,&H36,&H9D,&HB5,&HD8,&HB9,&HC3,&H3C,&H35,&HB6
   DATA &H3A,&H45,&H73,&HAD,&H18,&H1E,&HD7,&H8F,&H34,&H6E,&H6E,&H06,&HF4,&HFA,&H5E,&HDF
   DATA &H50,&H2A,&H35,&HCA,&H6B,&H13,&HBB,&H78,&HFE,&HA3,&HBC,&HC6,&HF5,&HCF,&H84,&H22
   DATA &H82,&H86,&H63,&H94,&H1A,&HF3,&H4B,&HE5,&H35,&HC2,&HFD,&HBE,&H19,&HD2,&H78,&H2E
   DATA &H04,&H0C,&HE8,&H19,&H8D,&H6C,&H0D,&H34,&H2F,&H53,&HEB,&HBA,&HC8,&HF6,&H0A,&H32
   DATA &HE4,&HCD,&H75,&H61,&HFA,&H6D,&H5A,&H98,&H5F,&H42,&HE9,&H94,&HEC,&HC4,&HAE,&HDB
   DATA &HBF,&H42,&H82,&H2C,&HA3,&H14,&HB6,&H34,&H8D,&H5A,&H64,&H53,&HFD,&HD1,&H6C,&H56
   DATA &H95,&H8D,&HD6,&H9F,&H51,&H43,&H94,&H1C,&HB5,&H53,&HC7,&HB4,&H3C,&HD8,&HE0,&HE8
   DATA &HEF,&HB1,&HFD,&HF3,&HEB,&H9A,&H7A,&H69,&HAC,&H7F,&HC3,&H3A,&H4A,&H8A,&HFD,&H9D
   DATA &H59,&H6E,&H8F,&H1D,&HC7,&H31,&HF2,&HA5,&H92,&H65,&H33,&H68,&H4C,&HA5,&HDE,&H4F
   DATA &H6A,&HA8,&HD9,&HFE,&H8F,&H42,&H69,&H7C,&H00,&H03,&H9A,&H4C,&H69,&HDB,&H83,&H4A
   DATA &H3D,&HDC,&HF5,&HD0,&H4C,&H9C,&HF7,&HC0,&HCC,&H12,&HBA,&HB8,&H29,&H6D,&H6B,&H08
   DATA &HF9,&HA8,&HCA,&H03,&H8E,&HF9,&HB8,&H37,&H3D,&H61,&HF6,&H1D,&HF3,&H0E,&H69,&HDE
   DATA &H14,&H62,&HC4,&HFD,&H7F,&HCC,&H31,&HD0,&H3F,&HF0,&H4F,&H97,&H29,&H1C,&HAD,&H37
   DATA &H86,&HE3,&HD9,&HB2,&HAB,&HC2,&HD1,&HCB,&HE0,&HE9,&HB9,&H10,&H3A,&H5E,&HFE,&HA6
   DATA &HA7,&HA9,&H43,&HCC,&HD2,&H85,&HFF,&H1B,&H48,&H9D,&HE5,&HA9,&H43,&HAC,&H00,&H04
   DATA &H15,&HAC,&H8A,&H31,&H7E,&HAF,&HF0,&HAB,&HBD,&H54,&H1F,&HDE,&H49,&H85,&HF6,&H4D
   DATA &H3E,&HC2,&HAB,&HD5,&HBD,&H9B,&HDE,&H49,&H25,&H83,&HD5,&H30,&H75,&H78,&H27,&H5D
   DATA &H79,&H37,&H75,&H58,&H4A,&HB9,&H12,&HB4,&HBA,&H2B,&HEF,&HEE,&HE4,&HF2,&HD8,&H27
   DATA &HF4,&H71,&H48,&HA3,&H04,&H2B,&HEF,&HB8,&H27,&H18,&HE1,&H75,&HC4,&HE4,&HC1,&H80
   DATA &H85,&H10,&H7A,&HB3,&HD3,&HC2,&HCE,&H46,&HFE,&HFC,&H18,&H22,&HE5,&HE8,&H9B,&HF6
   DATA &HCF,&H17,&H76,&H68,&HD5,&H50,&HCC,&HBC,&HDA,&HD8,&H79,&H43,&H2F,&H80,&H3E,&H5D
   DATA &H31,&H1E,&H1E,&H3C,&H3E,&H43,&H96,&H91,&H98,&H19,&HBE,&HD1,&H4A,&H28,&H7C,&H72
   DATA &H92,&H87,&HCF,&H9E,&H64,&HE2,&HAF,&H8D,&H4F,&H64,&HF4,&H16,&H24,&H6F,&HDB,&H06
   DATA &HC3,&HB4,&H7F,&H51,&HDB,&HC2,&HBA,&HB4,&H4D,&HA8,&H6B,&H5B,&H5A,&H66,&H6C,&HAB
   DATA &HBA,&H0B,&H6E,&H26,&HFE,&HDA,&HF8,&HA4,&HFC,&H75,&HF6,&HF0,&HFF,&H24,&HA9,&HA8
   DATA &H0B,&H37,&H2B,&H1F,&H40,&HEE,&H56,&H20,&H57,&HE1,&H17,&HE4,&H9F,&H72,&H16,&HE1
   DATA &HE1,&HB3,&H3C,&H1E,&HB7,&H90,&H47,&H7C,&H5C,&HCA,&H42,&H5C,&H1E,&HDF,&HF8,&HFC
   DATA &HB9,&HCE,&H71,&H3C,&HFD,&H9A,&HF2,&H59,&HA1,&H98,&H95,&H23,&HFA,&H66,&H62,&HD7
   DATA &HCC,&HE5,&H35,&H62,&HFC,&H9A,&HD6,&H87,&H47,&H4F,&H7E,&H7C,&HFA,&HF3,&HD3,&H27
   DATA &HBF,&H51,&HFE,&HF9,&HE9,&H8F,&H4F,&H8F,&H9E,&HB4,&HBA,&H0A,&H9F,&H3A,&H04,&HFE
   DATA &HE4,&HB7,&HD3,&HC6,&H4F,&H7F,&HFC,&HF4,&HC7,&H69,&HE3,&HC9,&H6F,&H9F,&H86,&H4F
   DATA &HEC,&H1E,&H3D,&H81,&HF6,&H3F,&H7F,&H3F,&H6D,&H9C,&H36,&HFE,&HFC,&H1D,&H16,&HFE
   DATA &H09,&H0E,&H06,&H50,&H0E,&H8F,&H95,&HBF,&HD5,&H7D,&H31,&H4F,&H0C,&HCA,&H40,&H5F
   DATA &HCC,&H2B,&HDC,&H64,&H50,&HB6,&H51,&H93,&H41,&HD9,&H45,&H35,&H83,&HB2,&H8F,&H2A
   DATA &H06,&H65,&H0E,&H35,&HAF,&HE3,&H05,&H2E,&HF9,&H3F,&H4A,&HE8,&HD7,&H62,&H4F,&H9E
   DATA &HA0,&H67,&H0C,&HE0,&H03,&HF4,&H8D,&H90,&H17,&HFD,&H5E,&H96,&H0C,&H78,&H56,&H44
   DATA &HFE,&HB2,&HF6,&H65,&H92,&HDE,&HDF,&H25,&HE4,&H2F,&H63,&H9F,&HEA,&H4E,&H23,&H47
   DATA &HA8,&HF6,&HC4,&H09,&H5B,&HB8,&H6C,&HFD,&H2E,&H9E,&HE2,&H71,&H4A,&HA5,&HC6,&H4C
   DATA &H67,&H62,&H37,&HC4,&H20,&H34,&HBC,&H96,&H4B,&H28,&H3F,&HCB,&H05,&H4A,&HAB,&HBC
   DATA &H9C,&HB4,&H96,&H8D,&HA1,&HFE,&HCA,&H2E,&HA1,&HF0,&HF1,&H09,&HF5,&HCB,&H6E,&HA2
   DATA &HCA,&H23,&HE7,&H35,&H73,&H4F,&H38,&H96,&H1A,&H28,&H33,&H50,&HAC,&HCD,&H71,&HAB
   DATA &H1F,&H84,&H22,&H4A,&HA8,&H3C,&H02,&HC3,&HD7,&H40,&H79,&H9C,&H0F,&H04,&H06,&H9E
   DATA &HBF,&H0F,&H5F,&H1D,&HAC,&H10,&H7F,&H99,&H28,&H32,&H15,&H63,&H1F,&H7B,&HFA,&H85
   DATA &HDF,&HDF,&HA5,&H9D,&HE7,&HE9,&HD3,&H17,&H67,&HC8,&H2E,&H43,&HA1,&HFD,&H7D,&HD2
   DATA &HDF,&HDF,&H07,&H47,&H33,&HF0,&HCC,&H3E,&HA1,&H78,&HFA,&H9E,&HE2,&HEC,&HA7,&H4F
   DATA &H1F,&H9F,&HF5,&H5F,&H13,&HFE,&HF0,&HA0,&HF3,&H11,&H4F,&HD5,&H03,&HC5,&HF3,&HF5
   DATA &H60,&HD0,&HA7,&HC2,&H61,&H99,&H3E,&H39,&HBC,&HFF,&HBA,&HF3,&H91,&HF4,&H83,&HE1
   DATA &HEB,&HA7,&HBA,&HBD,&H38,&H0B,&H95,&H4F,&HFB,&HF6,&H7C,&HFD,&HF4,&HB9,&HA3,&H79
   DATA &H68,&HEC,&H1C,&H86,&HB0,&H2F,&H90,&H9A,&HD6,&H13,&HD8,&H46,&HC2,&HBE,&H1E,&H5A
   DATA &H44,&H78,&H8F,&H12,&H68,&HB8,&HF7,&H40,&H0C,&H66,&HA9,&HC1,&HEF,&H0D,&H12,&H0A
   DATA &HFF,&H88,&HDB,&H7D,&H54,&H28,&HFF,&HF4,&HE1,&H15,&HA1,&HB6,&H5D,&HF6,&HD9,&H24
   DATA &H03,&H65,&HCF,&H49,&HDE,&HA7,&H5C,&HEF,&H67,&HC3,&H69,&H07,&H7A,&H33,&HB0,&HFB
   DATA &H2C,&HE3,&HCD,&HFE,&H35,&H0A,&HC6,&HF9,&HAD,&H3A,&H4F,&HD7,&HAD,&H3A,&HF8,&H79
   DATA &H1E,&H59,&H47,&H11,&H7A,&H99,&H77,&H6F,&H0D,&H8A,&HA8,&H7E,&HF5,&H16,&H01,&HC7
   DATA &HBE,&HE8,&H31,&HE9,&HE9,&H92,&H4D,&H3E,&HC6,&H60,&H23,&H7F,&HBF,&H0F,&HE6,&H21
   DATA &H7C,&H04,&H0B,&HBD,&H87,&HC4,&H8E,&HFB,&H74,&H35,&H64,&H1F,&HC2,&H11,&H0C,&H64
   DATA &H21,&HDC,&H3E,&HF5,&HFB,&HAB,&H78,&H7C,&H5C,&H7C,&HC4,&HF8,&HF8,&H9E,&HAB,&HDD
   DATA &H37,&H50,&HB3,&H97,&HF0,&HEE,&H13,&H45,&H88,&H44,&HCA,&HE0,&H3D,&H19,&HE3,&HE1
   DATA &H94,&HD9,&HC8,&H45,&H58,&H16,&HD7,&HAF,&H59,&HDC,&H0B,&H0E,&H8A,&HB3,&H8F,&H11
   DATA &H98,&H43,&HE9,&HDC,&HD2,&H18,&HCB,&HEF,&H2F,&HA2,&HF7,&H2D,&H35,&H70,&HFD,&H4B
   DATA &H8D,&HDB,&H6F,&H5D,&HFF,&H9C,&HAE,&HAD,&H96,&HB7,&H71,&H5B,&HFA,&HE1,&H01,&H70
   DATA &H73,&H9F,&H51,&HAD,&HFE,&H92,&H7C,&H18,&HB7,&HA5,&H7D,&H0B,&HE8,&HFD,&H39,&HF4
   DATA &H73,&HA6,&HF8,&H1D,&H48,&HEF,&HEC,&H51,&H6F,&HEE,&H71,&H52,&H33,&H79,&H29,&H64
   DATA &H83,&HEF,&H2E,&HC1,&H2C,&HAB,&H3E,&H9C,&HE9,&HC4,&HE6,&H95,&H53,&H87,&H61,&H3C
   DATA &H91,&H6F,&H81,&H89,&HBC,&H1B,&H05,&HF8,&HFB,&H68,&HFC,&H2F,&HF0,&HB8,&HFC,&H78
   DATA &HFD,&H5F,&H4E,&HFE,&HAA,&HD3,&HAA,&H7C,&H8B,&HD5,&H66,&H60,&HFD,&H75,&H35,&H7F
   DATA &HC7,&H55,&H80,&H21,&HAE,&H7C,&H21,&HCF,&HDD,&H41,&H98,&HC5,&H49,&HC6,&HAA,&H98
   DATA &H41,&HBD,&HF6,&HA5,&HD1,&HFE,&HA0,&H83,&H5A,&H82,&H1F,&H5F,&H68,&HB7,&H16,&HF3
   DATA &H37,&HB7,&HAB,&H9F,&H7B,&HA2,&HB9,&HE5,&HF2,&HC8,&H2F,&H0F,&H22,&H90,&H14,&H2E
   DATA &H7A,&H9D,&H08,&H6E,&HEA,&HE2,&HF4,&H8F,&H2B,&H9F,&H3A,&H82,&H7A,&HD3,&H1B,&HA8
   DATA &HF8,&HC8,&H26,&H9A,&HE7,&H12,&HCB,&H2F,&HCF,&H65,&HD3,&HAD,&H57,&H3F,&HFC,&HFD
   DATA &HC3,&HDF,&HCF,&H8F,&H9F,&H1F,&HD7,&H0E,&H6E,&HBD,&H72,&H51,&H1C,&H7D,&HF3,&H3F
   DATA &HCA,&HB7,&H5E,&HD5,&H0E,&H6C,&H0E,&HA1,&HB5,&H83,&H1F,&HFE,&HDE,&H3D,&HDB,&H3D
   DATA &HC3,&HF7,&H47,&H6F,&H34,&H43,&HA3,&H90,&HAB,&H1D,&H00,&H33,&H19,&H84,&HD6,&H0E
   DATA &HC0,&H33,&H19,&HF8,&H03,&HFA,&HE8,&H8D,&H29,&HAD,&H70,&HFA,&HBC,&HF5,&HEA,&HF9
   DATA &HB1,&H2B,&HAD,&H70,&H2A,&H09,&H38,&H74,&H14,&HBF,&H81,&H11,&HEA,&HE3,&H64,&H41
   DATA &HA1,&HA4,&H11,&HF5,&H35,&HED,&HE9,&HFF,&H84,&HFE,&HFB,&H4F,&H94,&H50,&H1D,&H83
   DATA &H06,&H93,&H8B,&HF2,&H27,&H09,&H95,&HEF,&HD1,&H1B,&H5D,&H03,&H85,&H42,&H5A,&H33
   DATA &H50,&HA2,&HDD,&HB3,&HE7,&HC7,&H2E,&H4A,&H0C,&H55,&H4A,&HC2,&H6C,&H54,&H71,&H54
   DATA &HF6,&HB1,&HCF,&H99,&HF0,&H26,&H46,&HEE,&HF9,&H1C,&H1C,&H87,&HE7,&HDE,&H59,&H9E
   DATA &HDB,&HC2,&H0C,&HDE,&H1C,&H25,&H80,&H21,&HEA,&H0A,&H71,&H57,&HFE,&H3C,&H1B,&HDE
   DATA &H39,&HBD,&HFB,&H11,&HF1,&H55,&HA4,&HE5,&HAF,&HBA,&H8B,&H52,&H7C,&H11,&H18,&HF3
   DATA &H4B,&H26,&H83,&HE2,&HB2,&H26,&H76,&HF1,&H5E,&H11,&HE0,&H78,&HC3,&H06,&H31,&H4C
   DATA &H9C,&H50,&H1E,&H87,&H7E,&HC4,&H76,&H02,&HF5,&H71,&H62,&HE0,&HBD,&H93,&H3C,&HAA
   DATA &H75,&H20,&H03,&HE3,&HD6,&H2F,&HFE,&HAA,&HAB,&HF3,&H63,&HD6,&HED,&H5B,&H49,&H34
   DATA &H37,&H56,&HF1,&HD9,&HEE,&H1C,&HC3,&H44,&H91,&HE1,&H6B,&HBB,&H4F,&H58,&HD9,&HEF
   DATA &H1F,&HB4,&H71,&H44,&H25,&H28,&HEF,&H9C,&H3C,&H74,&HC4,&H96,&H1A,&H06,&H9A,&HF9
   DATA &H53,&HA7,&HC5,&H9F,&HF0,&H3E,&HAD,&HE7,&HB7,&H8D,&HA7,&H98,&H72,&HFF,&HC6,&H9F
   DATA &H9D,&H85,&HE2,&HC7,&H35,&HE3,&H2A,&HA3,&HB3,&HAF,&H6B,&HAA,&H54,&H5B,&H5D,&HE7
   DATA &HD9,&HEF,&H3C,&HB7,&HBA,&H95,&HAA,&HB8,&H36,&H55,&HF9,&HE4,&H77,&HFE,&HDC,&H48
   DATA &H29,&H2D,&H3E,&H33,&H44,&H8A,&H01,&H1F,&H8D,&H04,&H7E,&H5E,&H4A,&H9D,&H37,&HBC
   DATA &H65,&HA3,&H11,&HF0,&H34,&HC7,&H55,&H2E,&H78,&H02,&H4F,&HAB,&HF4,&H64,&H31,&H5D
   DATA &H3B,&H4B,&HC3,&H40,&HEA,&H9F,&HA5,&HD5,&H8A,&HBC,&H04,&H1A,&H25,&HEB,&HB3,&HEA
   DATA &H4D,&HA7,&H92,&HF1,&H52,&HBE,&H7D,&HF4,&H5C,&HBE,&HBF,&HE7,&HA5,&H46,&H15,&H03
   DATA &HF5,&H18,&HC9,&H84,&H72,&H33,&HCF,&HFF,&HE0,&H2D,&H34,&H32,&HB6,&H2D,&HF5,&HD0
   DATA &H6F,&H21,&H55,&HAA,&H95,&H6A,&H78,&HBF,&H0B,&H77,&H02,&H52,&H7C,&H47,&H0C,&HFB
   DATA &H68,&H95,&H6A,&H2F,&HB0,&H6F,&H56,&H31,&HA2,&H02,&H7D,&H86,&H89,&HCA,&H77,&HAA
   DATA &HDA,&H6F,&H70,&H31,&H8F,&HB4,&HF3,&HE7,&H19,&H35,&HC3,&H3E,&HD2,&HCE,&HE7,&HB1
   DATA &H6D,&H4B,&HDA,&H3C,&H12,&HD7,&HFF,&HCD,&H26,&H7A,&HBF,&H55,&H6C,&HED,&H9A,&HA2
   DATA &HF3,&H5A,&H5D,&H8E,&H43,&HAD,&H0C,&H6D,&H07,&H0C,&H1E,&HAD,&HD4,&H88,&HC1,&HE0
   DATA &HB3,&HB2,&HF5,&HD5,&H28,&HBA,&HD4,&H8F,&HB0,&HA8,&H54,&H1F,&HD4,&H08,&H7F,&H50
   DATA &HAB,&H54,&HFD,&H28,&H1D,&H1B,&H67,&HDE,&H4F,&H68,&HE9,&H0F,&H95,&H5E,&H95,&H2F
   DATA &H54,&HFB,&HF8,&HF9,&HB9,&H8A,&HF4,&H7F,&H44,&H9C,&H84,&H67

circle_data: ' 256
   DATA &H08080000&,&H0827f000&,&H0867f000&,&H0887f000&,&H08c7f000&,&H08e7f000&,&H0927f000&,&H0947f000&,&H0987e000&,&H09c7e000&,&H09e7e000&,&H0a27d000&,&H0a47d000&,&H0a87c000&,&H0aa7c000&,&H0ae7b000&
   DATA &H0b07b000&,&H0b27a000&,&H0b679000&,&H0b879000&,&H0bc78000&,&H0be77000&,&H0c076000&,&H0c476000&,&H0c675000&,&H0c874000&,&H0cc73000&,&H0ce72000&,&H0d071000&,&H0d270000&,&H0d46f000&,&H0d86e000&
   DATA &H0da6d000&,&H0dc6c000&,&H0de6a000&,&H0e069000&,&H0e268000&,&H0e467000&,&H0e666000&,&H0e864000&,&H0ea63000&,&H0ec62000&,&H0ec60000&,&H0ee5f000&,&H0f05e000&,&H0f25c000&,&H0f25b000&,&H0f459000&
   DATA &H0f658000&,&H0f657000&,&H0f855000&,&H0f854000&,&H0fa52000&,&H0fa51000&,&H0fc4f000&,&H0fc4e000&,&H0fc4c000&,&H0fe4a000&,&H0fe49000&,&H0fe47000&,&H0fe46000&,&H0fe44000&,&H0fe43000&,&H0fe41000&
   DATA &H10040000&,&H0fe3e000&,&H0fe3c000&,&H0fe3b000&,&H0fe39000&,&H0fe38000&,&H0fe36000&,&H0fe35000&,&H0fc33000&,&H0fc31000&,&H0fc30000&,&H0fa2e000&,&H0fa2d000&,&H0f82b000&,&H0f82a000&,&H0f628000&
   DATA &H0f627000&,&H0f426000&,&H0f224000&,&H0f223000&,&H0f021000&,&H0ee20000&,&H0ec1f000&,&H0ec1d000&,&H0ea1c000&,&H0e81b000&,&H0e619000&,&H0e418000&,&H0e217000&,&H0e016000&,&H0de15000&,&H0dc13000&
   DATA &H0da12000&,&H0d811000&,&H0d410000&,&H0d20f000&,&H0d00e000&,&H0ce0d000&,&H0cc0c000&,&H0c80b000&,&H0c60a000&,&H0c409000&,&H0c009000&,&H0be08000&,&H0bc07000&,&H0b806000&,&H0b606000&,&H0b205000&
   DATA &H0b004000&,&H0ae04000&,&H0aa03000&,&H0a803000&,&H0a402000&,&H0a202000&,&H09e01000&,&H09c01000&,&H09801000&,&H09400000&,&H09200000&,&H08e00000&,&H08c00000&,&H08800000&,&H08600000&,&H08200000&
   DATA &H08000000&,&H07c00000&,&H07800000&,&H07600000&,&H07200000&,&H07000000&,&H06c00000&,&H06a00000&,&H06601000&,&H06201000&,&H06001000&,&H05c02000&,&H05a02000&,&H05603000&,&H05403000&,&H05004000&
   DATA &H04e04000&,&H04c05000&,&H04806000&,&H04606000&,&H04207000&,&H04008000&,&H03e09000&,&H03a09000&,&H0380a000&,&H0360b000&,&H0320c000&,&H0300d000&,&H02e0e000&,&H02c0f000&,&H02a10000&,&H02611000&
   DATA &H02412000&,&H02213000&,&H02015000&,&H01e16000&,&H01c17000&,&H01a18000&,&H01819000&,&H0161b000&,&H0141c000&,&H0121d000&,&H0121f000&,&H01020000&,&H00e21000&,&H00c23000&,&H00c24000&,&H00a26000&
   DATA &H00827000&,&H00828000&,&H0062a000&,&H0062b000&,&H0042d000&,&H0042e000&,&H00230000&,&H00231000&,&H00233000&,&H00035000&,&H00036000&,&H00038000&,&H00039000&,&H0003b000&,&H0003c000&,&H0003e000&
   DATA &H0003f000&,&H00041000&,&H00043000&,&H00044000&,&H00046000&,&H00047000&,&H00049000&,&H0004a000&,&H0024c000&,&H0024e000&,&H0024f000&,&H00451000&,&H00452000&,&H00654000&,&H00655000&,&H00857000&
   DATA &H00858000&,&H00a59000&,&H00c5b000&,&H00c5c000&,&H00e5e000&,&H0105f000&,&H01260000&,&H01262000&,&H01463000&,&H01664000&,&H01866000&,&H01a67000&,&H01c68000&,&H01e69000&,&H0206a000&,&H0226c000&
   DATA &H0246d000&,&H0266e000&,&H02a6f000&,&H02c70000&,&H02e71000&,&H03072000&,&H03273000&,&H03674000&,&H03875000&,&H03a76000&,&H03e76000&,&H04077000&,&H04278000&,&H04679000&,&H04879000&,&H04c7a000&
   DATA &H04e7b000&,&H0507b000&,&H0547c000&,&H0567c000&,&H05a7d000&,&H05c7d000&,&H0607e000&,&H0627e000&,&H0667e000&,&H06a7f000&,&H06c7f000&,&H0707f000&,&H0727f000&,&H0767f000&,&H0787f000&,&H07c7f000&

sprites: ' 2001
   DATA &H8044b00b&,&H9b85a00b&,&H96c7801f&,&H86e3d008&,&Ha3c2a019&,&H99862005&,&H8dc4d012&,&H9fa3d02d&,&H84c2e021&,&H8924b026&,&H9146f021&,&H9f80402d&,&H92655001&,&Ha601b003&,&H88811006&,&H88206023&
   DATA &H87834006&,&H9e64900f&,&Ha2c1a001&,&H88475024&,&Ha747d02c&,&H9e800006&,&Ha0e0000d&,&H91478020&,&H97470023&,&H95449008&,&Ha465c02b&,&Ha401f01d&,&H9582f027&,&H9c447011&,&H8fa7402b&,&Ha7416022&
   DATA &H8a83c00a&,&H8dc1a01d&,&H83e4702c&,&Ha184801a&,&H92000023&,&H8fe21006&,&H91e6c02b&,&H99675008&,&Ha1a18004&,&H90a51001&,&H9f23600c&,&H9901601b&,&H8905f02d&,&H91a3400f&,&H8221c012&,&Ha5c4702c&
   DATA &H96e7a011&,&H85470018&,&H9cc0e018&,&Ha0400010&,&Ha8c7a003&,&H96e4b017&,&H81438005&,&Ha121701b&,&Ha9e5001a&,&Ha9c3902a&,&H80a2100f&,&H94065008&,&Ha6c7600a&,&H94479016&,&H8f853006&,&H9605f00b&
   DATA &H9ac24019&,&Ha301a020&,&H91a5700b&,&H9bc1502b&,&H97465025&,&H9e01301f&,&H8461b014&,&H89025001&,&H85008012&,&Ha0c3b005&,&H8747f027&,&H8c06a00b&,&H9d61a010&,&H9a85e01d&,&H90c04028&,&H8c42d013&
   DATA &H87443028&,&H8e641024&,&Ha706800f&,&H8d071003&,&H8da15016&,&H96a3c008&,&H9542d022&,&H97c7002a&,&Ha9436010&,&H8fe6e02a&,&H95637020&,&Ha361901a&,&H96237016&,&Ha841b00c&,&Ha3c18026&,&H8087d013&
   DATA &H8e465011&,&Ha587e003&,&H8622c01e&,&H8a845026&,&H9c24301e&,&H96e1f012&,&H82e52011&,&Ha3616009&,&H80a63001&,&H89229010&,&H8023d00e&,&H80862011&,&H86a3f015&,&Ha263500f&,&H9603b00c&,&H9d87101c&
   DATA &Ha1e5c005&,&H8100900e&,&H93a4b019&,&H94a5f005&,&H83660010&,&H9c85a001&,&H8c820015&,&H9ce1c003&,&H8544302e&,&H94674028&,&H9603901a&,&H84c1e016&,&H9a413018&,&H80668021&,&H83265000&,&Ha5a4c028&
   DATA &H9507c002&,&H8ee40003&,&H8c67800e&,&H8d44600d&,&H97e2e026&,&Ha4e51014&,&H81479004&,&H9f21302c&,&H89c27011&,&Ha2e6f012&,&H8ca1f025&,&H8f212000&,&Ha3e26021&,&H9162502d&,&Ha306a015&,&H8e84d01a&
   DATA &H8ec36016&,&H94455028&,&H8641901a&,&H99805009&,&H8e43102a&,&H8607a010&,&Ha2266027&,&H80e2a028&,&H8363a021&,&H8ec45005&,&H92006014&,&H99439006&,&H9844e01b&,&Ha0e23028&,&H9fc1e025&,&H97431014&
   DATA &Ha980d01a&,&Ha9e6802b&,&H8943f011&,&H88834022&,&H8a411025&,&Ha044502a&,&Ha5835023&,&H8a074019&,&H88629008&,&H9d64a01e&,&H9ca5201a&,&Ha943401d&,&H9ac61015&,&H9783e008&,&Ha8e3d002&,&H87e5a008&
   DATA &H8125a001&,&H8ea1e029&,&H9e25a02d&,&H8881e00c&,&H9622700e&,&H97a5301a&,&H9ea4300e&,&H9c27a001&,&H97850014&,&Ha3c71010&,&H80e25024&,&H8fc2d013&,&H95a1500f&,&Ha3a61001&,&Ha762300d&,&H80424021&
   DATA &Ha1278002&,&Ha3453022&,&Ha145100c&,&Ha981702d&,&H93c1702c&,&H9c638001&,&H9f833011&,&H89e3f027&,&H86e3601f&,&H8943b028&,&H8824501d&,&H88c4a025&,&H84851011&,&H8042a001&,&H8642a029&,&Ha9a75024&
   DATA &H95e3300d&,&Ha903e002&,&Ha2002005&,&H9ec6b006&,&H86e52002&,&Ha346a009&,&H80a5e000&,&H9e06c009&,&H8f629011&,&H95c30025&,&Ha5e6600b&,&H82c2d022&,&Ha682401b&,&H9cc3b024&,&H8805701a&,&H9a630001&
   DATA &H84a68026&,&H98e6f007&,&H96a2b026&,&H97027006&,&H94e05015&,&H8182c01b&,&H8484502e&,&H98203012&,&H8866f01a&,&H8683202d&,&Ha7206024&,&H9f873016&,&H9404a012&,&H8d670008&,&H83475015&,&H8d03f019&
   DATA &H95251020&,&H9f85c02a&,&H9003400a&,&Ha2a3b02c&,&Ha9264002&,&H80642006&,&H88051013&,&H99c32013&,&H8824c000&,&H95c0900e&,&Ha2e2f028&,&Ha7659023&,&H8464c007&,&H8ce14027&,&H9aa70001&,&H83a7501f&
   DATA &H9a60b010&,&Ha9207011&,&H8bc5501b&,&Ha806601d&,&H93844023&,&Ha9c4701c&,&Ha1a24012&,&H9005301e&,&H8da10029&,&Ha3a7301e&,&H8921e01a&,&Ha1c5601f&,&H9a42200b&,&H99242027&,&H8484d01e&,&H8b81d022&
   DATA &H9c263002&,&H88807023&,&H8380e026&,&H8886d01e&,&H8fc7e01d&,&Ha107e018&,&Ha544a00f&,&H98e2d024&,&H94c7a01c&,&Ha0a5f004&,&H8e079000&,&H8ce54022&,&Ha6c7000d&,&H9bc2b005&,&H9c234018&,&H9a86e018&
   DATA &H9d420017&,&H9e07f003&,&H83009007&,&Ha601402d&,&H9922202d&,&H82e36005&,&H81471021&,&H9fe22004&,&Ha2065011&,&H9e87c018&,&H8041f008&,&Ha8e0c028&,&H8f622025&,&H83217020&,&H9104d00a&,&Ha7c11024&
   DATA &H85437004&,&H87e1c01e&,&Ha2626000&,&H86c79011&,&H9247702d&,&Ha5a1e022&,&H8581000c&,&H96600000&,&Ha141300f&,&Ha946200d&,&H9b03002e&,&H8f66a01c&,&Ha1c6c024&,&H9f275022&,&H9f25e01d&,&H9321d029&
   DATA &H90825006&,&H9824101f&,&H82c11019&,&H91a3001c&,&H81e00008&,&H87231011&,&H90c4a012&,&H84a26011&,&H88612019&,&H9120b025&,&H92a49001&,&Ha121901c&,&H96e3700a&,&Ha6058015&,&H95c1f00f&,&H9442900e&
   DATA &H82214002&,&H92251024&,&H8a27d00f&,&Ha6a3900b&,&Ha142500e&,&Ha7a5801f&,&H84648014&,&H84802019&,&H8c07d02e&,&H89220027&,&H8dc4e005&,&Ha2a3e016&,&H90a43007&,&Ha4e5f010&,&H9a61a026&,&Ha4211015&
   DATA &Ha6e77015&,&H8686500d&,&H8b85f013&,&H8445b011&,&H91c0702c&,&H86c7f00c&,&H9d03e013&,&H8d616020&,&H89225017&,&Ha606c02e&,&H9625c027&,&H8a41c01d&,&H9f854015&,&H9d44d019&,&Ha3845029&,&H9420e010&
   DATA &H8b47a006&,&H9c46b01e&,&H80254015&,&H9f262001&,&H9644900e&,&H9484e01c&,&H93267016&,&H86a11004&,&Ha445c000&,&Ha1a3502d&,&H86028023&,&H83033028&,&Ha6e19022&,&H9e055016&,&H8cc5f00d&,&Ha6056027&
   DATA &H9507500d&,&Ha1633011&,&H80c55002&,&Ha8441007&,&H90c2801f&,&H8e05a01d&,&Ha125601c&,&H9b218028&,&H91e41013&,&H9c26800e&,&Ha5c0f024&,&H9024001e&,&H9de4c005&,&H8866801a&,&H90864018&,&H9921e025&
   DATA &Ha9c5800a&,&Ha707002e&,&H8b072018&,&Ha945e014&,&Ha6221015&,&H8ec6802a&,&H9c23301a&,&Ha867f010&,&H87445017&,&H98e2b00b&,&H99e04028&,&H99c0b01b&,&Ha922f020&,&Ha6a6101f&,&H99e46003&,&H94426012&
   DATA &H80459026&,&Ha5671007&,&Ha0269007&,&Ha7056021&,&H92447015&,&H8127e00e&,&Ha646f020&,&H80c03005&,&H9ca1001b&,&H8781d006&,&H8147801a&,&H91a0202b&,&Ha0e20020&,&H80418025&,&H9623b015&,&Ha544f023&
   DATA &H9ba1f00d&,&H8224302b&,&H96025000&,&H84c4c019&,&H8ae3b00d&,&Ha986f02a&,&Ha3e2f006&,&H8f21b013&,&Ha061d002&,&H80e1b012&,&H8380a014&,&H84635009&,&H9666e003&,&H9fc78013&,&H8144f00d&,&H9c836013&
   DATA &H9401d017&,&H9524201d&,&Ha222b007&,&H8986602a&,&Ha1a4102d&,&H9a024013&,&H9b245014&,&H93a64010&,&H9ee58021&,&H9662d008&,&H8600700f&,&Ha5e7c022&,&H98a4c027&,&Ha461e012&,&H81e48021&,&Ha0a6d000&
   DATA &H8a05001a&,&H8a84902c&,&Ha124200f&,&Ha4430001&,&H8880a009&,&Ha043e00a&,&H8526d02b&,&H9de01004&,&H89254007&,&Ha223a015&,&H91459021&,&H93c22021&,&H86473007&,&H89a49010&,&H9482701d&,&Ha3e37011&
   DATA &H9c002009&,&Ha3239008&,&H9065c01d&,&H8be4100f&,&H89678022&,&Ha5a5300d&,&Ha3a70010&,&H9c07e00c&,&H84a35018&,&H80a33009&,&Ha9a30013&,&H89e22028&,&H91a73011&,&H8387e01f&,&H86a37012&,&H9d218021&
   DATA &H8e61302a&,&Ha526c020&,&H91051005&,&H9be6a00c&,&H9265602d&,&H9966601f&,&H8ae0f026&,&Ha4623023&,&H8407c025&,&H8d00f011&,&H92801001&,&Ha901e00e&,&H9f618019&,&H9045d018&,&H9b21700a&,&H88463009&
   DATA &Ha824100b&,&H92e62006&,&Ha6a6c02e&,&H8920c00d&,&Ha8a55007&,&H86c4d029&,&Ha0053004&,&Ha664f023&,&H9fe5e007&,&H9e42a008&,&H9602000a&,&H8842a007&,&H96019005&,&H8cc3402b&,&H89609000&,&H8966000a&
   DATA &Ha2c61006&,&H9f217018&,&Ha303f006&,&H9065f003&,&H8f421021&,&Ha2821012&,&H96268013&,&H8f263004&,&H9784e028&,&Ha205d01b&,&H8b86b016&,&H9721d02d&,&H85e30014&,&H8341d01e&,&H85e46008&,&H9200d023&
   DATA &H9404e02a&,&H95c34007&,&H87435013&,&H90411005&,&H95a35006&,&H8dc4c00b&,&H8a43200f&,&H8ba42006&,&H9a87a00f&,&H91423011&,&H90e28008&,&H8be37023&,&H80c7e016&,&H81a72005&,&H91a1c009&,&Ha5e4c01f&
   DATA &H89043020&,&H8926a000&,&H8667f027&,&H8d603000&,&Ha582602e&,&H8de53026&,&Ha246801e&,&H84226024&,&Ha3423021&,&H8564d002&,&Ha2220022&,&H9267001a&,&H8b84c00d&,&H84a54016&,&Ha021f022&,&H8ea0802d&
   DATA &H8d076016&,&H87021015&,&H80c7f027&,&H8ac3802b&,&H9167d01a&,&H9263a013&,&Ha8c2002e&,&H94842020&,&H9e65e005&,&H8fc71020&,&H9e435002&,&H9662c005&,&H88a2a004&,&H87a1701b&,&H92c2d014&,&H8146f005&
   DATA &H85c3f021&,&Ha4c45008&,&H95476001&,&H8980b004&,&H8925e010&,&Ha5c7201a&,&H9ea0d025&,&H9727d027&,&H9803b001&,&H93e61021&,&H8423a001&,&H9227d01d&,&Ha362d017&,&H9a21e00c&,&H99e46028&,&H8ea2d004&
   DATA &H9f27702b&,&H8721f00c&,&H8e063029&,&H8a063008&,&H9c422029&,&H8fc7a009&,&H98c38007&,&H9042000b&,&H9622b023&,&H91655004&,&H9f24b004&,&H9e80b01c&,&H97032027&,&H9ea75019&,&H8a00000c&,&Ha0a3502d&
   DATA &H8840f015&,&H8fe19025&,&H8f20200b&,&H98a3e01e&,&H84a45000&,&Ha924502a&,&H8b471003&,&Ha0c0a027&,&Ha6c40016&,&Ha3652016&,&Ha7662022&,&H88a7200d&,&H8c226004&,&H9884f021&,&H92832012&,&H9086a023&
   DATA &H9926700a&,&Ha3048004&,&H98e2b008&,&Ha4a4b02e&,&Ha3e3b02b&,&H82c47029&,&H8461a005&,&H85a1c006&,&H8dc2e005&,&H9047e021&,&H93c37012&,&Ha505401d&,&H9223f02a&,&Ha0e3f010&,&H98473011&,&H9ca0702e&
   DATA &Ha903d02d&,&Ha6866005&,&H92043011&,&H80846001&,&Ha400301c&,&Ha942b003&,&H8f209004&,&H8182802c&,&Ha407b01c&,&H82667017&,&Ha2c0d02b&,&H8f42601b&,&H8101d006&,&H85620000&,&H9700001b&,&Ha6471001&
   DATA &H85c3202d&,&Ha343301a&,&H95602021&,&H9460700e&,&H8325702e&,&H9a40f014&,&H9b82a01a&,&H96e55008&,&H9c87e00d&,&H9360201c&,&H8a810010&,&Ha201e01f&,&H8bc19015&,&H88c5c01e&,&Ha946a004&,&H97239002&
   DATA &H9226600d&,&H8cc16007&,&H88a75014&,&H9c00d023&,&Ha824500c&,&H80c3d023&,&Ha946c005&,&H9b42001a&,&H8cc1a02d&,&H8f05002c&,&Ha700200e&,&H89876026&,&Ha840501a&,&Ha4e3100a&,&H8160a028&,&Ha441600b&
   DATA &H8906d005&,&H9a801011&,&H8b40a00c&,&H98a7602e&,&H80c5b014&,&H89645026&,&H9c80b01f&,&H9b00f007&,&H9400e004&,&H9446e004&,&H9b81e01c&,&H88663005&,&H9e446010&,&Ha501c002&,&H8f47f01c&,&H89274004&
   DATA &Ha5804023&,&H9786000c&,&H9d012015&,&Ha9c27000&,&H91a60000&,&H9145600c&,&H9141e004&,&H8846b02e&,&H81047023&,&Ha081f009&,&H9b872003&,&Ha2c5500e&,&H98c53022&,&H8b032011&,&H9d410024&,&H9722302c&
   DATA &Ha503e01e&,&H8de4b00d&,&H9663b00f&,&H8d039025&,&H90c3601e&,&Ha4a5202a&,&H9c40c00d&,&H92408014&,&H8420000a&,&H9fe7e00f&,&Ha722e024&,&H9783700e&,&H82e0d01a&,&H9940b006&,&H91266009&,&H9646702a&
   DATA &H80e36002&,&Ha641300f&,&Ha4e60014&,&Ha563500a&,&H9940101d&,&H8d425002&,&H8c805010&,&H83449000&,&H9d434025&,&H8840d005&,&Ha2c5902a&,&H8bc3501c&,&Ha4269008&,&H9ee2901c&,&Ha2e7500c&,&Ha4a70010&
   DATA &Ha6e1a00f&,&H9941c015&,&Ha4866013&,&Ha8618016&,&H9a61601d&,&Ha8637009&,&H8ac62001&,&Ha4c1f025&,&H8823c01f&,&H8662902a&,&Ha3e1b007&,&H81c1001d&,&H9c25d024&,&H83a5c02c&,&H9282300d&,&H92844013&
   DATA &H9661b026&,&Ha724700e&,&Ha884902d&,&H88e10009&,&H9f41e00e&,&H89070017&,&H81827007&,&H8302c010&,&H88c0900d&,&H9ae3301e&,&H9ca7d006&,&H9882a014&,&Ha781f021&,&H9582702c&,&H9c41901d&,&H8f07e011&
   DATA &H9763c01f&,&H8ac24016&,&H9641701b&,&H9024a01e&,&H8b60c02d&,&H8dc78023&,&H85806026&,&Ha3433022&,&Ha0e48008&,&H8103f02b&,&H97c5800c&,&H9fa5a009&,&Ha1e14028&,&H90842015&,&H9b85f029&,&H8be1e00a&
   DATA &H91e5a00f&,&H9224f010&,&H9d045017&,&H8be1701c&,&H83c3a013&,&H88803012&,&Ha2406016&,&H86e76010&,&Ha8e2d018&,&H82a14016&,&H95c6600c&,&H9304d02c&,&H9542f012&,&H90c62025&,&H98467019&,&H9286300c&
   DATA &H9725b016&,&Ha9e1502c&,&H9002201c&,&H94a2901f&,&H85e24014&,&H82444020&,&Ha2c7001d&,&H86e2f017&,&H93a68019&,&Ha282101e&,&H8582a015&,&Ha3231023&,&H8d41a01e&,&H94402023&,&H93e47015&,&H8ce05024&
   DATA &H8422a00d&,&H9a233006&,&H9d069018&,&Ha600500e&,&H8223800a&,&H9b84800a&,&H82814002&,&H9847602e&,&Ha987a01f&,&H8f668026&,&H8687900e&,&Ha5a6f023&,&H8127a01f&,&Ha5e48018&,&H8f444029&,&H96c02014&
   DATA &H9943c02d&,&H9fa53024&,&H8ec6401f&,&H81008025&,&H8b630007&,&H82257006&,&H81861029&,&H93a3c027&,&H95c2102b&,&Ha706e018&,&H9540e015&,&Ha487b00a&,&H93a04003&,&H94878029&,&H8e849007&,&H86c1a010&
   DATA &Ha9e07021&,&Ha480a02a&,&Ha707b001&,&H9ee16014&,&H9266200f&,&H9742e00d&,&H80247000&,&H9a80002b&,&H8a067023&,&H9002d028&,&H98c4c01e&,&H82c67021&,&H92027001&,&H96816012&,&H8a635014&,&H9442a013&
   DATA &Ha221b020&,&H96c5e028&,&H99211019&,&H81a7c022&,&H83e4b022&,&H8745e02e&,&H9c24200d&,&H92030028&,&H86a4202b&,&H85e3902c&,&H9ca6a019&,&H8c67b009&,&H96e48028&,&H8f86d025&,&H9523b02b&,&H9486e012&
   DATA &Ha486400f&,&Ha6c7501e&,&H9ea3a028&,&H92a58017&,&H9b676016&,&H8a675000&,&H81617019&,&Ha101e00e&,&H8e61602b&,&H9145d00f&,&H81478012&,&H9aa3e005&,&H8d067016&,&H8b20500b&,&H8c210018&,&H9f22002d&
   DATA &Ha0e1e020&,&H8e63900e&,&H9d80e02d&,&H8e26a00c&,&H9b02e019&,&H9a640016&,&H9ac1a018&,&Ha8e4400a&,&Ha903a027&,&H88a42005&,&Ha9a01006&,&Ha4671003&,&H9046d02d&,&H84a01001&,&H8b23a020&,&Ha604502a&
   DATA &H8e64e003&,&Ha1c7a01d&,&Ha707a000&,&H98e5102b&,&H83c3700a&,&H8301f016&,&H8585d02c&,&Ha6412023&,&H8b82e00a&,&Ha7073014&,&Ha0c4a01f&,&H94e5802b&,&H8566a00b&,&H84464021&,&H8ec30020&,&Ha606f018&
   DATA &H89c5700d&,&Ha664c023&,&H9a622018&,&H8ae6702d&,&H9944400d&,&H8025900e&,&H9267601f&,&H80a1602e&,&H8364c013&,&Ha482102a&,&Ha486b00c&,&H9c244020&,&Ha8e2202a&,&H81c00012&,&H88e18012&,&H88465021&
   DATA &H8b02b009&,&Ha7c3b028&,&Ha207f007&,&H96201021&,&H9584e028&,&H92636005&,&H8c63901b&,&H8560502e&,&H94a5c01c&,&Ha4a42012&,&Ha4819022&,&H96c7a01d&,&H8b22c019&,&H80a2001d&,&H90c1100c&,&H8a86301b&
   DATA &H9cc38022&,&Ha6005003&,&H8585c02e&,&H8f642029&,&H9fa13006&,&H90269001&,&Ha223a004&,&H8ba22015&,&H9922500f&,&H9205601d&,&H87865007&,&H9942000e&,&Ha4e48019&,&Ha164a024&,&H9226100b&,&H9be7b021&
   DATA &H8ae0a01b&,&Ha2065019&,&H97801017&,&H8385a002&,&H9e03000e&,&H9a60800b&,&H80c2c01f&,&Ha222402b&,&H81201020&,&H8b42300d&,&H9347100f&,&H9821400a&,&H8c830007&,&H9442d027&,&H8907d01f&,&H9201001d&
   DATA &H88c5400f&,&H8b212024&,&H8cc0a010&,&H9262501c&,&H9045502b&,&Ha1033029&,&H8f40f02d&,&H9143200d&,&Ha8010014&,&H91405005&,&H9701e023&,&H83c3d00a&,&H8767d025&,&H93252006&,&H85654021&,&H8d41c025&
   DATA &H85c60018&,&Ha8607004&,&H8a645018&,&H8522102b&,&H8425200c&,&H81843007&,&Ha5879021&,&H9841102b&,&H9a811005&,&H9562101d&,&H96a09008&,&Ha4e22012&,&H8d475019&,&H80853029&,&H83a09002&,&H81a61003&
   DATA &H9cc09008&,&H8e657008&,&Ha4c3c01e&,&H91a1a01d&,&H8a04a014&,&Ha6c71017&,&H8246b01b&,&Ha4c0502e&,&H8b25f020&,&H8062101b&,&H91606008&,&Ha4220023&,&H86c2d021&,&H8a87002d&,&H8004d02a&,&H92c0c007&
   DATA &H8ca61026&,&Ha5259023&,&H9143e01d&,&H9b47f004&,&H8be1f01f&,&H82a60010&,&H8da39014&,&H81024013&,&H81638027&,&Ha7a61013&,&H9a03c01d&,&Ha1814007&,&H9b455017&,&H95a07026&,&H9c86900c&,&Ha682a008&
   DATA &H9127c018&,&Ha562e01f&,&H89e0502a&,&H8e00202e&,&Ha4452000&,&H96428015&,&H84030020&,&Ha8c6c00c&,&Ha4e7e024&,&H8b05f01b&,&H8fe5300b&,&H9f63701a&,&Ha320d002&,&Ha683700b&,&H9921f011&,&H89c3d016&
   DATA &H99450020&,&H8b61601f&,&H9b672007&,&Ha0a7e000&,&H88a3d022&,&H95e06026&,&H90453016&,&H8820101e&,&H8f408010&,&H9e44a007&,&Ha1e3f005&,&H8e426004&,&Ha843200e&,&H8044701e&,&Ha0c1602c&,&H91e12003&
   DATA &Ha7823016&,&H8d87401e&,&H9c45b006&,&Ha303f010&,&H8c45801c&,&H92a6a000&,&H83600017&,&H8ec69005&,&H8d03b020&,&H8c452024&,&H9061b029&,&H9021601b&,&H97e6301e&,&H9865301f&,&H86a03012&,&H8341600c&
   DATA &Ha9879001&,&Ha164f000&,&H88029026&,&H95804004&,&H9980702c&,&Ha1245025&,&H81c27002&,&H9ba4802d&,&H84226028&,&Ha303d023&,&H8b254012&,&H94a55021&,&H99852011&,&Ha4a1b023&,&H9007201e&,&H8e208011&
   DATA &H8d807027&,&Ha106b00a&,&H87059029&,&Ha6208018&,&H8da71022&,&H9607002d&,&H8205301c&,&H8867d017&,&H9c01701c&,&Ha4273014&,&Ha300401b&,&H9283401e&,&Ha8651026&,&H88853006&,&H8dc1b01e&,&H95052024&
   DATA &Ha305c000&,&H95a61026&,&H8f83e010&,&H9287400f&,&H9c817025&,&H8a855005&,&Ha904f026&,&H93e67025&,&Ha782a01a&,&Ha8255014&,&Ha644e002&,&H9262a02d&,&H8fc15027&,&H9e82a00b&,&H97815026&,&H8aa05011&
   DATA &Ha822a005&,&H82017015&,&H9902b01c&,&H8400c01a&,&Ha2e3d00d&,&Ha763e021&,&H8a21000e&,&H8d831021&,&H8a41202e&,&H9e04001b&,&Ha525a005&,&H8c00400b&,&H8b03d012&,&H8e80101e&,&H9d062015&,&Ha022101c&
   DATA &H99c2e021&,&H88632017&,&H9cc6c004&,&Ha401c011&,&H9d879017&,&Ha3276018&,&H8be7e01a&,&H9147f005&,&H9d855015&,&H9de2f004&,&H86c2201b&,&Ha963b01f&,&H84877016&,&H8f046002&,&H91c6e00f&,&H8c06e00c&
   DATA &H9441b023&,&H86c34004&,&H97a73008&,&H8f44601e&,&H87e7202d&,&H95a64017&,&H9aa05003&,&Ha4a64017&,&H86016013&,&Ha4205001&,&H87048018&,&H9302c02e&,&H94a3e001&,&Ha205a026&,&H84c22005&,&H98a18027&
   DATA &H85c3c016&,&Ha1465024&,&H8505a014&,&H8626800f&,&Ha3272001&,&H9163d012&,&H90c0100d&,&H8fc62001&,&H9620a016&,&H8244001e&,&H82c58010&,&H87c49003&,&H84e16019&,&H89a51006&,&H9044f019&,&Ha3213029&
   DATA &H81e5002e&,&H9cc71002&,&H9ec0e016&,&H9761000a&,&H93e3400a&,&H94431023&,&H9945c01c&,&H8d44100f&,&Ha9e6d014&,&H87e05026&,&H83c0b025&,&H9ec2400b&,&H8de3c020&,&H9f034019&,&H9a67600f&,&H8b21200c&
   DATA &H9d669009&,&H92a5c011&,&H8d058003&,&Ha3268020&,&H86e61014&,&H9f029015&,&Ha263d00c&,&H8821100f&,&H82e71027&,&H8a63a019&,&H9a029016&,&Ha067d013&,&H9fc0c023&,&Ha142b010&,&H93c0a005&,&H9ea2c005&
   DATA &H87c67012&,&Ha8834012&,&Ha384e010&,&H8582e015&,&H9f21d017&,&H9764601e&,&H9441501d&,&Ha984301a&,&H8444301f&,&H91a5402b&,&H9ee5d01f&,&Ha882a01a&,&H86c7800d&,&H8ba4f022&,&H82c05017&,&H89c57028&
   DATA &H95021017&,&H8ae00027&,&H9c01a024&,&H87e5a01e&,&H8fc49013&,&H9323401d&,&H8441b01c&,&H9922200e&,&H9e87601b&,&H8a646003&,&Ha686c018&,&H81c48029&,&H94627011&,&H96a3f02b&,&H8ca72017&,&H80860011&
   DATA &H9fe00008&,&H82466011&,&H85625028&,&H9081d00b&,&Ha4e0c020&,&H8284000a&,&H82a31029&,&Ha683701e&,&H8da3501b&,&H8261a007&,&Ha141c004&,&H88c29025&,&H9ce7802e&,&H80609007&,&H9201b026&,&Ha9c0202d&
   DATA &H8e057004&,&H87244010&,&Ha225e02e&,&H88807010&,&H92e1e01f&,&H8f63b024&,&H8a03901a&,&H82810007&,&H9763d029&,&H85813011&,&H9ae5900c&,&H9c05601e&,&H86455006&,&H8a207007&,&H8667300c&,&Ha166c000&
   DATA &H8f245013&,&H8ac5602a&,&H85a39020&,&H8f85b02d&,&H9221a00e&,&Ha187701e&,&H9543e013&,&Ha2c2a012&,&H8fe56013&,&H82e0302c&,&Ha7e04011&,&Ha343500d&,&H9c64b029&,&Ha721601c&,&H97a25000&,&H8c24b005&
   DATA &H9226c007&,&H99a55012&,&Ha6e2000a&,&H9e87f00d&,&Ha9e7301e&,&H8320c003&,&Ha422f029&,&H8822f01c&,&H8887b020&,&H82665015&,&H83c4300a&,&H8ec76014&,&Ha583d02e&,&H90a66029&,&H89c6e021&,&H96214024&
   DATA &H9863a00d&,&H9d01f019&,&H9c64600c&,&H9ac25029&,&Ha5671015&,&H8b43c010&,&H85c1501b&,&H81859006&,&H98205013&,&H99612022&,&H93e55001&,&H8f419003&,&H93e71012&,&H9e00d00a&,&H9027500c&,&H8b40e010&
   DATA &H8e244019&,&H9304f015&,&H9a60c01e&,&Ha7c2a012&,&H8ee38014&,&H83866011&,&H89053012&,&H8e82100b&,&H8f86e01d&,&H9ce3b029&,&H9e87e023&,&H9dc30007&,&H93e7b026&,&H9de15000&,&H85a23007&,&Ha083d00c&
   DATA &H95647022&,&H94c76004&,&H88c3d021&,&Ha4c47014&,&H9023402b&,&H8a24f012&,&H8162b02d&,&H96246009&,&H90c38020&,&H98833024&,&Ha1073014&,&Ha9e50018&,&H84c2a007&,&H8563002c&,&H8d611003&,&H9883d00f&
   DATA &H9ec11029&,&H89c4b020&,&H89608007&,&Ha3a2c01d&,&H83e11019&,&H91223015&,&Ha380d01b&,&Ha8c2e023&,&Ha446a02a&,&Ha3270003&,&H8607e017&,&H82a6302e&,&H8c432028&,&Ha607d022&,&H9366a021&,&H93e64018&
   DATA &H88c05028&,&H9dc2b015&,&Ha4e36028&,&H8f218019&,&H8f46a023&,&H8d815016&,&H9fa7100a&,&Ha8652025&,&H8347102c&,&Ha3028003&,&Ha801701a&,&H86053019&,&H83c4f022&,&H9b845029&,&H8fe5f02d&,&H8706d028&
   DATA &H9ee71027&,&Ha5e41003&,&H9562c02b&,&H8701d025&,&H9c078013&,&H9f64b026&,&Ha0e39024&,&Ha586600e&,&Ha322c01c&,&H95418026&,&Ha8665016&,&H96c1800a&,&Ha5a6f009&,&H8540a027&,&H9a449022&,&H90c60025&
   DATA &H9961901d&,&Ha8211011&,&H8825102e&,&H8f825015&,&Ha2a3e008&,&H9c270018&,&Ha8078025&,&H9641c013&,&H9025e006&,&H84037015&,&H8fe6c01f&,&H85a56001&,&Ha2c2b024&,&H87c6f002&,&H84a78000&,&Ha2438017&
   DATA &H8c02a00f&,&H8e654024&,&H83808002&,&Ha9852011&,&H92e2f02a&,&H98432004&,&H96c0801c&,&H8681b000&,&H9987c012&,&H8763d005&,&H9946d00c&,&H8fe60012&,&Ha4e24002&,&H9b64302b&,&H96a17017&,&H8ee3f00c&
   DATA &H96e36025&,&H81a06014&,&H8f223027&,&H9cc1400e&,&H83a5602e&,&Ha2a6f027&,&Ha5629017&,&H8427b00e&,&H9ec02018&,&Ha040b004&,&H84a11027&,&H8623e024&,&H8226700c&,&Ha225d003&,&H8bc5600c&,&H92c3002a&
   DATA &H9d805005&,&H8ce7202c&,&H88879015&,&H86262020&,&Ha862e025&,&H8441f023&,&H95007000&,&H8fa04015&,&Ha345502d&,&H8da2a007&,&H9b64a017&,&H97e13000&,&H8fe63018&,&H9f02200b&,&H94e54010&,&H84a46014&
   DATA &H85257014&,&H9922b026&,&Ha360000e&,&Ha900802b&,&H9dc33002&,&H80c2d007&,&H94231016&,&H84c54008&,&Ha442801d&,&H94613012&,&Ha721f028&,&H85a1b01b&,&Ha4018019&,&H8567a027&,&H90677018&,&H9563a028&
   DATA &H8700e00d&,&H9c86a00a&,&H9ca26020&,&H8763800d&,&Ha9475012&,&H9964700a&,&H82856025&,&H94444027&,&H88e13003&,&H82a05020&,&H8cc0c02c&,&Ha1021002&,&H9540500b&,&H9be5601d&,&H95659005&,&H9d45f000&
   DATA &H9de3f02b&,&H9b85002b&,&H98642010&,&H8903a00d&,&H8627b019&,&H88a3700a&,&H95a7e02d&,&Ha467600c&,&Ha762301e&,&H9681701a&,&Ha4a55006&,&Ha0c0b026&,&H9d270006&,&H8fe6c01c&,&H8da3202c&,&H89a0c026&
   DATA &H8382a009&,&Ha881b010&,&H8062800c&,&H94050006&,&H86047015&,&H8104802c&,&Ha485101c&,&H93a1302c&,&Ha3230006&,&H92e7c02c&,&H9b039024&,&H98e3b005&,&H9981e021&,&H90874026&,&H8d66102b&,&H93a1d00f&
   DATA &Ha9c39014&,&H8067d029&,&H9bc5101c&,&H99413021&,&H9e879029&,&H9201b022&,&H81a76027&,&H9de7e009&,&H8561d00e&,&H99273021&,&H97e1a022&,&Ha086301d&,&H83060003&,&H9e00501d&,&H94e4c002&,&H8b62400f&
   DATA &H9ee62000&,&H85078028&,&H8526202e&,&H9ee3d023&,&H84e72002&,&H9462b009&,&H89860020&,&Ha265102e&,&H89a20004&,&H82034003&,&Ha241c000&,&H87a0302e&,&H9de1e01d&,&Ha320202a&,&H8ea24028&,&H99a40009&
   DATA &Ha2e73000&,&Ha386701d&,&H92a1701e&,&H9fc01024&,&H91e28015&,&H94045011&,&H88a2f01f&,&H87227010&,&H98228024&,&Ha2628014&,&H84a4902d&,&Ha7634024&,&H8862901f&,&H8223c013&,&H9fa55007&,&H82210009&
   DATA &H90c19023&,&Ha063b024&,&Ha5a2d00d&,&Ha8c45004&,&H91859002&,&H9d856007&,&Ha943602a&,&H9d84501a&,&H8b02c004&,&H9d87800d&,&H88c3100d&,&H89250021&,&Ha524a005&,&H8de74001&,&Ha104b01b&,&H8182600a&
   DATA &H9462902d&,&Ha0a4a026&,&H8e672013&,&H99a2900e&,&Ha883601a&,&Ha344c020&,&H8847202e&,&H9e273016&,&H8544302a&,&H8de1c017&,&H97278007&,&Ha8023021&,&H86c6c013&,&H87c6b025&,&H8185202a&,&H9e836024&
   DATA &H92e33013&,&H9805101b&,&H9b000005&,&H94869019&,&H9ea44020&,&H9c445013&,&H9de13021&,&H97e39010&,&Ha504102a&,&H9ec61011&,&H88a6c028&,&H84853004&,&Ha6a13007&,&H9ec6a009&,&H9520f000&,&H95e1e00e&
   DATA &H8c833024&,&H96810019&,&Ha0614028&,&H8be0f01f&,&H8146e01a&,&H83065027&,&Ha7a79015&,&Ha1e0e024&,&H91420008&,&H9d061023&,&H83620013&,&H85c3c019&,&Ha2c5101c&,&H8967b023&,&H86a23024&,&H8963c02d&
   DATA &H94c11020&,&H8221f002&,&H97e24009&,&Ha8009007&,&H93276019&,&H9081001e&,&H8c41b028&,&H9262b025&,&H9b832024&,&H8d608009&,&H9fc73005&,&Ha2067016&,&H88a26025&,&H85a09028&,&H80c30012&,&H85256018&
   DATA &Ha920f01f&,&H92e5501f&,&H8187000a&,&H9760c029&,&H9e621012&,&Ha8a4202c&,&Ha361a022&,&H9c80900c&,&H9525b008&,&Ha7a3902c&,&Ha9651018&,&Ha606c007&,&H8fc45028&,&H8b438016&,&Ha2c6b029&,&H8d23e01e&
   DATA &Ha202e002&,&H89e7f023&,&H95043023&,&H8fc65011&,&H98c1e02e&,&Ha9c5e00c&,&H9887a027&,&Ha0a51004&,&H9025b004&,&H9b86a023&,&H8c26801a&,&H83422005&,&H9647501a&,&H93c3300e&,&Ha5251011&,&H87a4d00e&
   DATA &H94e58005&,&H8402102a&,&Ha6a4f017&,&H9c64e013&,&H98a4a017&,&H8e06b028&,&Ha181b005&,&H8e828016&,&H9aa1d02c&,&H9102e015&,&H9ea64028&,&Ha2a72027&,&H8886e00e&,&H83a1002d&,&H84a72012&,&H95671003&
   DATA &Ha2673026&,&Ha6a73022&,&H9942101b&,&Ha7e3e024&,&H8865501a&,&H8721100f&,&Ha340900c&,&Ha3a2f01b&,&H8d02a023&,&H8a666002&,&H8963901c&,&Ha6c1c004&,&H9e241024&,&Ha307d00c&,&H8be1c01b&,&H8b628021&
   DATA &H88c46028&,&H8f212007&,&H8480e00d&,&H9d05202a&,&H84807008&,&Ha6e7e00f&,&H9042f007&,&H8606b008&,&H89c11016&,&H9cc1c005&,&Ha746001e&,&H87873003&,&Ha0653024&,&H9a65202d&,&H97868004&,&H86c0d026&
   DATA &Ha1817019&,&Ha980600a&,&Ha1049025&,&H8104a02d&,&Ha883b012&,&Ha7434007&,&Ha8a69011&,&H82401026&,&H8365401f&,&H8ec2f02a&,&H83a6702a&,&Ha4639015&,&H9780e025&,&Ha8e21008&,&Ha160a02b&,&H94442023&
   DATA &H87c3c00c&,&Ha4c6c013&,&H98a7f009&,&H9c27001f&,&Ha2a2301c&,&H9c87d011&,&H83606017&,&H99847014&,&H9981001e&,&H8e60601f&,&Ha807f001&,&H80c7600d&,&H84e7f001&,&H8d261011&,&H8347201b&,&H94c19026&
   DATA &H91648020&,&H9686a014&,&H9040c02a&,&Ha545a008&,&Ha1c2e003&,&H8e665002&,&Ha727e023&,&H89c0001c&,&H96c3b006&,&H8987a00a&,&Ha0424029&,&H9145c001&,&H8307700f&,&H9363c01f&,&H8e22700d&,&H8f023025&
   DATA &Ha2845003&,&H86c6a011&,&H84e55023&,&H90009008&,&H87a4801b&,&H86c70015&,&H9c861014&,&Ha184b00e&,&H94c75021&,&H9306b014&,&H85057004&,&Ha3029027&,&H90a1302c&,&H9386501f&,&H8f05201b&,&H9f64801e&
   DATA &H98e27005&,&H88414022&,&Ha085e00b&,&H91674003&,&Ha7c43002&,&H9ec71002&,&Ha8a2c022&,&H8827f02d&,&H9b23101f&,&H9b00b00f&,&H8581a029&,&H9f27c016&,&H8d44d02a&,&H87a07012&,&Ha9867010&,&Ha541101a&
   DATA &Ha0a48004&,&H8247f006&,&Ha8a67003&,&H8be5401b&,&H9642902d&,&H97239004&,&H82e5b01a&,&H99a6d022&,&H8b808022&,&H87032020&,&H9463a026&,&Ha1206025&,&H89c05027&,&H80416002&,&H9ae56019&,&H8b027001&
   DATA &H9527d000&,&H80872009&,&H9fa26019&,&H93a10021&,&H9767301d&,&H9a42a014&,&H8b82e011&,&H83670011&,&Ha0a1e02a&,&H9122c02d&,&H8ae20024&,&H97a0f00a&,&H83e4f019&,&H89425019&,&Ha803500b&,&H80c22025&
   DATA &H82a73026&,&Ha5067028&,&H9cc45005&,&H9a41b002&,&H8202702b&,&H8f85e007&,&H8167a013&,&H8c41f02b&,&Ha0a39001&,&H9a23d000&,&H8ea7f01c&,&Ha5c76025&,&H90059009&,&H8666b02c&,&Ha0e4c021&,&H8887a01f&
   DATA &H9f81b000&,&Ha160800f&,&Ha5e5a024&,&Ha582201f&,&H9c402001&,&H93c6900d&,&H94009026&,&H92c4d00f&,&Ha186302b&,&H8b25402c&,&H8863201f&,&H87c7402c&,&H8864801d&,&H8664302c&,&Ha5c76001&,&H96c4d00c&
   DATA &H95638008&,&H9620800b&,&H8a21b012&,&H86050014&,&H88a2f007&,&Ha445b018&,&H9fc2900a&,&H8fc0b026&,&H90e3d023&,&H8d05e026&,&H8f262023&,&H82e4902b&,&H9d235020&,&H9947a016&,&H92022003&,&H9283500b&
   DATA &H9a210022&,&H89c6800f&,&Ha724c008&,&Ha3428012&,&H9141f008&,&Ha7a77024&,&H9844501c&,&Ha982600d&,&H9e824017&,&H9dc01012&,&H93201025&,&Ha9c6a008&,&Ha185b000&,&H82a5d00f&,&H9ec6b028&,&H9f440004&
   DATA &H8fe7b00e&,&H88841029&,&H9587a000&,&H8ec4700b&,&Ha223f003&,&Ha1019018&,&H92242001&,&Ha7a49014&,&H8201601a&,&Ha763600f&,&H93e2702c&,&H90278015&,&Ha906801e&,&H9b63c01a&,&H9186402b&,&H9e00602d&
   DATA &Ha227100c